defmodule Webuntis.JsonRpc do
  @moduledoc false

  @webuntis_host "mobile.webuntis.com"
  @webuntis_path "/ms/app/"

  def request(method, params) do
    params = Map.put(params, "auth", Webuntis.Auth.JsonAuth.auth_map())

    # params as list
    data = %{"jsonrpc" => "2.0", "id" => "", "method" => method, "params" => [params]}

    HTTPoison.post!(
      "https://" <>
        @webuntis_host <> @webuntis_path <> Webuntis.Auth.JsonAuth.school_id() <> "?m=" <> method,
      Jason.encode!(data),
      [
        {"Content-Type", "application/json; charset=UTF-8"}
      ]
    ).body
  end
end
