defmodule Webuntis.MixProject do
  use Mix.Project

  def project do
    [
      app: :webuntis,
      version: "2.1.1",
      elixir: "~> 1.9",
      start_permanent: Mix.env() == :prod,
      deps: deps(),
      package: package(),
      docs: docs()
    ]
  end

  defp package do
    [
      description: "This library is no longer being developed. Please use \"untis\" instead.",
      licenses: ["MIT"],
      links: %{"GitLab" => "https://gitlab.com/xp4u1/webuntis"}
    ]
  end

  def application do
    [
      extra_applications: [:logger],
      applications: [:httpoison]
    ]
  end

  defp docs do
    [
      logo: "docs/logo-hexdocs.png",
      extras: ["docs/json-rpc.md"]
    ]
  end

  defp deps do
    [
      {:httpoison, "~> 1.6"},
      {:jason, "~> 1.0"},
      {:ex_doc, "~> 0.13", only: :dev}
    ]
  end
end
